class Bank {
    private int accounts[];
    private int naccounts;
    private int ntransacts = 0;
    public Bank (int nacc, int init) {
	naccounts = nacc;
	accounts = new int[nacc];
	for (int i = 0; i < nacc; i++) {
	    accounts[i] = init;
	}
    }
    public synchronized void transfer( int from, int to, int amount) {
	if (accounts[from] < amount) return;
	accounts[from] -= amount;
	accounts[to] += amount;
	ntransacts++;
	if (ntransacts % 1000 == 0) test();
    }
    public void test() {
	int sum = 0;
	for (int i = 0; i < naccounts; i++) {
	    sum+= accounts[i];
	}
	System.out.println("Transactions: "+ntransacts+" sum: "+sum);
    }
} 
public class TransferThread extends Thread {
    private Bank bank;
    private int fromAccount;
    public TransferThread(Bank bank, int fromAccount) {
      this.bank = bank;
      this.fromAccount = fromAccount;
    }
    @Override
    public void run() {
	try {
	  while (!interrupted()) {
	      int toAccount = (int) (Math.random()*NACCOUNTS);
	      int amount = (int) (Math.random()*INIT_AMOUNT);
	      bank.transfer(fromAccount, toAccount, amount);
	      sleep(5);
	  }
	} catch (InterruptedException e) {}
    }

    public static void main (String args[]) {
	Bank b = new Bank(NACCOUNTS, INIT_AMOUNT);
	b.test();
	for (int i = 0; i < NACCOUNTS; i++) {
	    TransferThread t = new TransferThread(b, i);
	    t.setPriority(Thread.NORM_PRIORITY + i % 2);
	    t.start();
	}
    }
    public static final int NACCOUNTS = 100;
    public static final int INIT_AMOUNT = 1000;
}